# -*- Autoconf -*-
#
# Copyright (c) 2005-2007 The ABINIT Group (Yann Pouillon)
# All rights reserved.
#
# This file is part of the ABINIT software package. For license information,
# please see the COPYING file in the top-level directory of the ABINIT source
# distribution.
#

# Generated by make-macros-env on 2007/08/31 06:51:07 +0000

#
# Environment variables relevant to ABINIT
#

#
# IMPORTANT NOTE
#
# This file has been automatically generated by the make-macros-env
# script. Any change will systematically be overwritten.
#



# ABI_ENV_INIT()
# --------------
#
# Declares ABINIT environment variables and sets their default values.
#
AC_DEFUN([ABI_ENV_INIT],
[

 dnl Library archiver flags for 64-bit objects
 if test "${ARFLAGS_64BITS}" = ""; then
  ARFLAGS_64BITS=""
 fi
 AC_SUBST(ARFLAGS_64BITS)

 dnl C preprocessor flags
 if test "${CPPFLAGS}" = ""; then
  CPPFLAGS=""
 fi
 AC_SUBST(CPPFLAGS)

 dnl C preprocessor flags for 64-bit objects
 if test "${CPPFLAGS_64BITS}" = ""; then
  CPPFLAGS_64BITS=""
 fi
 AC_SUBST(CPPFLAGS_64BITS)

 dnl C preprocessor flags for optimization
 if test "${CPPFLAGS_OPT}" = ""; then
  CPPFLAGS_OPT=""
 fi
 AC_SUBST(CPPFLAGS_OPT)

 dnl Additional C preprocessor flags
 if test "${EXTRA_CPPFLAGS}" = ""; then
  EXTRA_CPPFLAGS=""
 fi
 AC_SUBST(EXTRA_CPPFLAGS)

 dnl C compiler flags
 if test "${CFLAGS}" = ""; then
  CFLAGS=""
 fi
 AC_SUBST(CFLAGS)

 dnl C flags for 64-bit objects
 if test "${CFLAGS_64BITS}" = ""; then
  CFLAGS_64BITS=""
 fi
 AC_SUBST(CFLAGS_64BITS)

 dnl C compiler flags for optimization
 if test "${CFLAGS_OPT}" = ""; then
  CFLAGS_OPT=""
 fi
 AC_SUBST(CFLAGS_OPT)

 dnl C linker flags for optimization
 if test "${CC_LDFLAGS_OPT}" = ""; then
  CC_LDFLAGS_OPT=""
 fi
 AC_SUBST(CC_LDFLAGS_OPT)

 dnl Additional C compiler flags
 if test "${EXTRA_CFLAGS}" = ""; then
  EXTRA_CFLAGS=""
 fi
 AC_SUBST(EXTRA_CFLAGS)

 dnl Additional C linker flags
 if test "${EXTRA_CC_LDFLAGS}" = ""; then
  EXTRA_CC_LDFLAGS=""
 fi
 AC_SUBST(EXTRA_CC_LDFLAGS)

 dnl C++ compiler flags
 if test "${CXXFLAGS}" = ""; then
  CXXFLAGS=""
 fi
 AC_SUBST(CXXFLAGS)

 dnl C++ flags for 64-bit objects
 if test "${CXXFLAGS_64BITS}" = ""; then
  CXXFLAGS_64BITS=""
 fi
 AC_SUBST(CXXFLAGS_64BITS)

 dnl C++ compiler flags for optimization
 if test "${CXXFLAGS_OPT}" = ""; then
  CXXFLAGS_OPT=""
 fi
 AC_SUBST(CXXFLAGS_OPT)

 dnl C++ linker flags for optimization
 if test "${CXX_LDFLAGS_OPT}" = ""; then
  CXX_LDFLAGS_OPT=""
 fi
 AC_SUBST(CXX_LDFLAGS_OPT)

 dnl Additional C++ compiler flags
 if test "${EXTRA_CXXFLAGS}" = ""; then
  EXTRA_CXXFLAGS=""
 fi
 AC_SUBST(EXTRA_CXXFLAGS)

 dnl Additional C++ linker flags
 if test "${EXTRA_CXX_LDFLAGS}" = ""; then
  EXTRA_CXX_LDFLAGS=""
 fi
 AC_SUBST(EXTRA_CXX_LDFLAGS)

 dnl Fortran compiler flags
 if test "${FCFLAGS}" = ""; then
  FCFLAGS=""
 fi
 AC_SUBST(FCFLAGS)

 dnl Fortran flags for 64-bit objects
 if test "${FCFLAGS_64BITS}" = ""; then
  FCFLAGS_64BITS=""
 fi
 AC_SUBST(FCFLAGS_64BITS)

 dnl Fortran compiler flags for optimization
 if test "${FCFLAGS_OPT}" = ""; then
  FCFLAGS_OPT=""
 fi
 AC_SUBST(FCFLAGS_OPT)

 dnl Additional Fortran compiler flags
 if test "${EXTRA_FCFLAGS}" = ""; then
  EXTRA_FCFLAGS=""
 fi
 AC_SUBST(EXTRA_FCFLAGS)

 dnl Fortran linker flags
 if test "${FC_LDFLAGS}" = ""; then
  FC_LDFLAGS=""
 fi
 AC_SUBST(FC_LDFLAGS)

 dnl Fortran linker flags for optimization
 if test "${FC_LDFLAGS_OPT}" = ""; then
  FC_LDFLAGS_OPT=""
 fi
 AC_SUBST(FC_LDFLAGS_OPT)

 dnl Additional Fortran linker flags
 if test "${EXTRA_FC_LDFLAGS}" = ""; then
  EXTRA_FC_LDFLAGS=""
 fi
 AC_SUBST(EXTRA_FC_LDFLAGS)

 dnl Fortran flags for fixed-form source files
 if test "${FCFLAGS_FIXEDFORM}" = ""; then
  FCFLAGS_FIXEDFORM=""
 fi
 AC_SUBST(FCFLAGS_FIXEDFORM)

 dnl Fortran flags for free-form source files
 if test "${FCFLAGS_FREEFORM}" = ""; then
  FCFLAGS_FREEFORM=""
 fi
 AC_SUBST(FCFLAGS_FREEFORM)

 dnl Markdown text-to-HTML processor flags
 if test "${MDFLAGS}" = ""; then
  MDFLAGS=""
 fi
 AC_SUBST(MDFLAGS)

 dnl LaTeX flags
 if test "${LTXFLAGS}" = ""; then
  LTXFLAGS=""
 fi
 AC_SUBST(LTXFLAGS)

 dnl DVI->PDF converter flags
 if test "${PDFFLAGS}" = ""; then
  PDFFLAGS=""
 fi
 AC_SUBST(PDFFLAGS)
]) # ABI_ENV_INIT



# ABI_ENV_BACKUP()
# ----------------
#
# Saves all ABINIT environment variables.
#
AC_DEFUN([ABI_ENV_BACKUP],
[dnl All variables will be saved, yet please note that they are conditionally
 dnl restored. Empty ones might be ignored (see ABI_ENV_RESTORE for details).

 dnl Save Library archiver
 abi_env_AR="${AR}"

 dnl Save Library archiver flags for 64-bit objects
 abi_env_ARFLAGS_64BITS="${ARFLAGS_64BITS}"

 dnl Save C preprocessor
 abi_env_CPP="${CPP}"

 dnl Save C preprocessor flags
 abi_env_CPPFLAGS="${CPPFLAGS}"

 dnl Save C preprocessor flags for 64-bit objects
 abi_env_CPPFLAGS_64BITS="${CPPFLAGS_64BITS}"

 dnl Save C preprocessor flags for optimization
 abi_env_CPPFLAGS_OPT="${CPPFLAGS_OPT}"

 dnl Save Additional C preprocessor flags
 abi_env_EXTRA_CPPFLAGS="${EXTRA_CPPFLAGS}"

 dnl Save C compiler
 abi_env_CC="${CC}"

 dnl Save C compiler flags
 abi_env_CFLAGS="${CFLAGS}"

 dnl Save C flags for 64-bit objects
 abi_env_CFLAGS_64BITS="${CFLAGS_64BITS}"

 dnl Save C compiler flags for optimization
 abi_env_CFLAGS_OPT="${CFLAGS_OPT}"

 dnl Save C linker flags for optimization
 abi_env_CC_LDFLAGS_OPT="${CC_LDFLAGS_OPT}"

 dnl Save Additional C compiler flags
 abi_env_EXTRA_CFLAGS="${EXTRA_CFLAGS}"

 dnl Save Additional C linker flags
 abi_env_EXTRA_CC_LDFLAGS="${EXTRA_CC_LDFLAGS}"

 dnl Save C++ compiler
 abi_env_CXX="${CXX}"

 dnl Save C++ compiler flags
 abi_env_CXXFLAGS="${CXXFLAGS}"

 dnl Save C++ flags for 64-bit objects
 abi_env_CXXFLAGS_64BITS="${CXXFLAGS_64BITS}"

 dnl Save C++ compiler flags for optimization
 abi_env_CXXFLAGS_OPT="${CXXFLAGS_OPT}"

 dnl Save C++ linker flags for optimization
 abi_env_CXX_LDFLAGS_OPT="${CXX_LDFLAGS_OPT}"

 dnl Save Additional C++ compiler flags
 abi_env_EXTRA_CXXFLAGS="${EXTRA_CXXFLAGS}"

 dnl Save Additional C++ linker flags
 abi_env_EXTRA_CXX_LDFLAGS="${EXTRA_CXX_LDFLAGS}"

 dnl Save Fortran compiler
 abi_env_FC="${FC}"

 dnl Save Fortran compiler flags
 abi_env_FCFLAGS="${FCFLAGS}"

 dnl Save Fortran flags for 64-bit objects
 abi_env_FCFLAGS_64BITS="${FCFLAGS_64BITS}"

 dnl Save Fortran compiler flags for optimization
 abi_env_FCFLAGS_OPT="${FCFLAGS_OPT}"

 dnl Save Additional Fortran compiler flags
 abi_env_EXTRA_FCFLAGS="${EXTRA_FCFLAGS}"

 dnl Save Fortran linker flags
 abi_env_FC_LDFLAGS="${FC_LDFLAGS}"

 dnl Save Fortran linker flags for optimization
 abi_env_FC_LDFLAGS_OPT="${FC_LDFLAGS_OPT}"

 dnl Save Additional Fortran linker flags
 abi_env_EXTRA_FC_LDFLAGS="${EXTRA_FC_LDFLAGS}"

 dnl Save Fortran flags for fixed-form source files
 abi_env_FCFLAGS_FIXEDFORM="${FCFLAGS_FIXEDFORM}"

 dnl Save Fortran flags for free-form source files
 abi_env_FCFLAGS_FREEFORM="${FCFLAGS_FREEFORM}"

 dnl Save Markdown text-to-HTML processor flags
 abi_env_MDFLAGS="${MDFLAGS}"

 dnl Save LaTeX flags
 abi_env_LTXFLAGS="${LTXFLAGS}"

 dnl Save DVI->PDF converter flags
 abi_env_PDFFLAGS="${PDFFLAGS}"
]) # ABI_ENV_BACKUP



# ABI_ENV_RESTORE()
# -----------------
#
# Restores all previously-saved ABINIT environment variables.
#
AC_DEFUN([ABI_ENV_RESTORE],
[dnl The following ensures that non-empty environment variables always override
 dnl what is read from the config files. For now, we let the config file define
 dnl empty environment variables though.

 dnl Restore Library archiver
 if test "${abi_env_AR}" != ""; then
  AR="${abi_env_AR}"
 fi

 dnl Restore Library archiver flags for 64-bit objects
 if test "${abi_env_ARFLAGS_64BITS}" != ""; then
  ARFLAGS_64BITS="${abi_env_ARFLAGS_64BITS}"
 fi

 dnl Restore C preprocessor
 if test "${abi_env_CPP}" != ""; then
  CPP="${abi_env_CPP}"
 fi

 dnl Restore C preprocessor flags
 if test "${abi_env_CPPFLAGS}" != ""; then
  CPPFLAGS="${abi_env_CPPFLAGS}"
 fi

 dnl Restore C preprocessor flags for 64-bit objects
 if test "${abi_env_CPPFLAGS_64BITS}" != ""; then
  CPPFLAGS_64BITS="${abi_env_CPPFLAGS_64BITS}"
 fi

 dnl Restore C preprocessor flags for optimization
 if test "${abi_env_CPPFLAGS_OPT}" != ""; then
  CPPFLAGS_OPT="${abi_env_CPPFLAGS_OPT}"
 fi

 dnl Restore Additional C preprocessor flags
 if test "${abi_env_EXTRA_CPPFLAGS}" != ""; then
  EXTRA_CPPFLAGS="${abi_env_EXTRA_CPPFLAGS}"
 fi

 dnl Restore C compiler
 if test "${abi_env_CC}" != ""; then
  CC="${abi_env_CC}"
 fi

 dnl Restore C compiler flags
 if test "${abi_env_CFLAGS}" != ""; then
  CFLAGS="${abi_env_CFLAGS}"
 fi

 dnl Restore C flags for 64-bit objects
 if test "${abi_env_CFLAGS_64BITS}" != ""; then
  CFLAGS_64BITS="${abi_env_CFLAGS_64BITS}"
 fi

 dnl Restore C compiler flags for optimization
 if test "${abi_env_CFLAGS_OPT}" != ""; then
  CFLAGS_OPT="${abi_env_CFLAGS_OPT}"
 fi

 dnl Restore C linker flags for optimization
 if test "${abi_env_CC_LDFLAGS_OPT}" != ""; then
  CC_LDFLAGS_OPT="${abi_env_CC_LDFLAGS_OPT}"
 fi

 dnl Restore Additional C compiler flags
 if test "${abi_env_EXTRA_CFLAGS}" != ""; then
  EXTRA_CFLAGS="${abi_env_EXTRA_CFLAGS}"
 fi

 dnl Restore Additional C linker flags
 if test "${abi_env_EXTRA_CC_LDFLAGS}" != ""; then
  EXTRA_CC_LDFLAGS="${abi_env_EXTRA_CC_LDFLAGS}"
 fi

 dnl Restore C++ compiler
 if test "${abi_env_CXX}" != ""; then
  CXX="${abi_env_CXX}"
 fi

 dnl Restore C++ compiler flags
 if test "${abi_env_CXXFLAGS}" != ""; then
  CXXFLAGS="${abi_env_CXXFLAGS}"
 fi

 dnl Restore C++ flags for 64-bit objects
 if test "${abi_env_CXXFLAGS_64BITS}" != ""; then
  CXXFLAGS_64BITS="${abi_env_CXXFLAGS_64BITS}"
 fi

 dnl Restore C++ compiler flags for optimization
 if test "${abi_env_CXXFLAGS_OPT}" != ""; then
  CXXFLAGS_OPT="${abi_env_CXXFLAGS_OPT}"
 fi

 dnl Restore C++ linker flags for optimization
 if test "${abi_env_CXX_LDFLAGS_OPT}" != ""; then
  CXX_LDFLAGS_OPT="${abi_env_CXX_LDFLAGS_OPT}"
 fi

 dnl Restore Additional C++ compiler flags
 if test "${abi_env_EXTRA_CXXFLAGS}" != ""; then
  EXTRA_CXXFLAGS="${abi_env_EXTRA_CXXFLAGS}"
 fi

 dnl Restore Additional C++ linker flags
 if test "${abi_env_EXTRA_CXX_LDFLAGS}" != ""; then
  EXTRA_CXX_LDFLAGS="${abi_env_EXTRA_CXX_LDFLAGS}"
 fi

 dnl Restore Fortran compiler
 if test "${abi_env_FC}" != ""; then
  FC="${abi_env_FC}"
 fi

 dnl Restore Fortran compiler flags
 if test "${abi_env_FCFLAGS}" != ""; then
  FCFLAGS="${abi_env_FCFLAGS}"
 fi

 dnl Restore Fortran flags for 64-bit objects
 if test "${abi_env_FCFLAGS_64BITS}" != ""; then
  FCFLAGS_64BITS="${abi_env_FCFLAGS_64BITS}"
 fi

 dnl Restore Fortran compiler flags for optimization
 if test "${abi_env_FCFLAGS_OPT}" != ""; then
  FCFLAGS_OPT="${abi_env_FCFLAGS_OPT}"
 fi

 dnl Restore Additional Fortran compiler flags
 if test "${abi_env_EXTRA_FCFLAGS}" != ""; then
  EXTRA_FCFLAGS="${abi_env_EXTRA_FCFLAGS}"
 fi

 dnl Restore Fortran linker flags
 if test "${abi_env_FC_LDFLAGS}" != ""; then
  FC_LDFLAGS="${abi_env_FC_LDFLAGS}"
 fi

 dnl Restore Fortran linker flags for optimization
 if test "${abi_env_FC_LDFLAGS_OPT}" != ""; then
  FC_LDFLAGS_OPT="${abi_env_FC_LDFLAGS_OPT}"
 fi

 dnl Restore Additional Fortran linker flags
 if test "${abi_env_EXTRA_FC_LDFLAGS}" != ""; then
  EXTRA_FC_LDFLAGS="${abi_env_EXTRA_FC_LDFLAGS}"
 fi

 dnl Restore Fortran flags for fixed-form source files
 if test "${abi_env_FCFLAGS_FIXEDFORM}" != ""; then
  FCFLAGS_FIXEDFORM="${abi_env_FCFLAGS_FIXEDFORM}"
 fi

 dnl Restore Fortran flags for free-form source files
 if test "${abi_env_FCFLAGS_FREEFORM}" != ""; then
  FCFLAGS_FREEFORM="${abi_env_FCFLAGS_FREEFORM}"
 fi

 dnl Restore Markdown text-to-HTML processor flags
 if test "${abi_env_MDFLAGS}" != ""; then
  MDFLAGS="${abi_env_MDFLAGS}"
 fi

 dnl Restore LaTeX flags
 if test "${abi_env_LTXFLAGS}" != ""; then
  LTXFLAGS="${abi_env_LTXFLAGS}"
 fi

 dnl Restore DVI->PDF converter flags
 if test "${abi_env_PDFFLAGS}" != ""; then
  PDFFLAGS="${abi_env_PDFFLAGS}"
 fi
]) # ABI_ENV_RESTORE
