#
# Makefile for the linear algebra library embedded in ABINIT
#

include ../../config.mk

all_targets all etsf_xc: install
	@echo "$(etsf_xc_pkg_name) is now ready for use."

uncompress: uncompress-stamp
	@echo "$(etsf_xc_pkg_name) has been uncompressed."

configure: configure-stamp
	@echo "$(etsf_xc_pkg_name) has been configured."

build: build-stamp
	@echo "$(etsf_xc_pkg_name) has been built."

install: install-stamp
	@echo "$(etsf_xc_pkg_name) has been installed."

uncompress-stamp:
	gzip -cd $(abinit_srcdir)/lib/etsf_xc/$(etsf_xc_pkg_name).tar.gz | tar xf -
	touch uncompress-stamp

configure-stamp: uncompress
	cd $(etsf_xc_pkg_name) && CPP="$(CPP)" CPPFLAGS="$(CPPFLAGS)" CC="$(CC)" CFLAGS="$(CFLAGS)" FC="$(FC)" FCFLAGS="$(FCFLAGS_FREEFORM) $(FCFLAGS_ETSF_XC)" ./configure --enable-fortran --with-string_f="$(abinit_builddir)/lib/string_f"
	touch configure-stamp

build-stamp: configure
	cd $(etsf_xc_pkg_name) && $(MAKE)
	$(AR) $(ARFLAGS) libetsf_xc.a $(etsf_xc_pkg_name)/src/*.o
	-$(RANLIB) libetsf_xc.a
	touch build-stamp

install-stamp: build
	cp $(etsf_xc_pkg_name)/src/xc_types.mod .
	cp $(etsf_xc_pkg_name)/src/libxc.mod .
	touch install-stamp

clean:
	rm -f uncompress-stamp configure-stamp build-stamp install-stamp
