#
# Makefile for the XML Fortran 90 library embedded in ABINIT
#

include ../../config.mk

all_targets all fox: install
	@echo "$(fox_pkg_name) is now ready for use."

uncompress: uncompress-stamp
	@echo "$(fox_pkg_name) has been uncompressed."

configure: configure-stamp
	@echo "$(fox_pkg_name) has been configured."

build: build-stamp
	@echo "$(fox_pkg_name) has been built."

install: install-stamp
	@echo "$(fox_pkg_name) has been installed in tmp."

uncompress-stamp:
	gzip -cd $(abinit_srcdir)/lib/fox/$(fox_pkg_name).tar.gz | tar xf -
	mv FoX-2.1.1 $(fox_pkg_name)
	touch uncompress-stamp

configure-stamp: uncompress
	-mkdir tmp
	cd $(fox_pkg_name) && \
	 ./config/configure \
	 CPP="$(CPP)" \
	 CPPFLAGS="$(CPPFLAGS_FOX)" \
	 CC="$(CC)" \
	 CFLAGS="$(CFLAGS_FOX)" \
	 CXX="$(CXX)" \
	 CXXFLAGS="$(CXXFLAGS_FOX)" \
	 F77="$(FC)" \
	 FFLAGS="$(FCFLAGS_FIXEDFORM) $(FCFLAGS_FOX)" \
	 F90="$(FC)" \
	 F90FLAGS="$(FCFLAGS_FREEFORM) $(FCFLAGS_FOX)" \
	 FC="$(FC)" \
	 FCFLAGS="$(FCFLAGS_FREEFORM) $(FCFLAGS_FOX)"
	touch configure-stamp

build-stamp: configure
	cd $(fox_pkg_name) && $(MAKE)
	touch build-stamp

install-stamp: build
	cp $(fox_pkg_name)/objs/lib/*.a .
	cp $(fox_pkg_name)/objs/finclude/*.mod .
	touch install-stamp

clean:
	rm -rf $(fox_pkg_name) tmp
	rm -f uncompress-stamp configure-stamp build-stamp install-stamp
