#
# Makefile for the NetCDF library embedded in ABINIT
#

include ../../config.mk

all_targets all string_f: install
	@echo "$(string_f_pkg_name) is now ready for use."

uncompress: uncompress-stamp
	@echo "$(string_f_pkg_name) has been uncompressed."

configure: configure-stamp
	@echo "$(string_f_pkg_name) has been configured."

build: build-stamp
	@echo "$(string_f_pkg_name) has been built."

install: install-stamp
	@echo "$(string_f_pkg_name) has been installed in tmp."

uncompress-stamp:
	gzip -cd $(abinit_srcdir)/lib/string_f/$(string_f_pkg_name).tar.gz | tar xf -
	touch uncompress-stamp

configure-stamp: uncompress
	-mkdir tmp
	cd $(string_f_pkg_name) && \
	 CPP="$(CPP)" \
	 CPPFLAGS="$(CPPFLAGS_STRING_F)" \
	 CC="$(CC)" \
	 CFLAGS="$(CFLAGS_STRING_F)" \
	 ./configure --prefix=$(PWD)/tmp
	touch configure-stamp

build-stamp: configure
	cd $(string_f_pkg_name) && $(MAKE)
	touch build-stamp

install-stamp: build
	cd $(string_f_pkg_name) && $(MAKE) install
	touch install-stamp

clean:
	rm -rf $(string_f_pkg_name) tmp
	rm -f uncompress-stamp configure-stamp build-stamp install-stamp
