complex function interp(n,z,f,z0,zz)
use defs_basis

!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifdef HAVE_FORTRAN_INTERFACES
 use interfaces_15gw, except_this_one => interp
#endif
!End of the abilint section

implicit none
integer n
complex :: z(n), f(n), z0, zz
integer i
complex a, b
complex :: c(n), zz_minus_z0_to_i
real(dp) :: x(n), smrt
!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifndef HAVE_FORTRAN_INTERFACES
 real(dp) :: clinfit
#endif
!End of the abilint section

x(:) = real(z(:))
smrt = clinfit(n,x,f,a,b)
if( smrt>0.1/Ha_eV) then
  write(*,*) '**WARNING: the values are not linear'
  write(*,*) smrt,a,b,f
endif
interp = a * zz + b
return
end

complex function dinterp(n,z,f,z0,zz)
use defs_basis

!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifdef HAVE_FORTRAN_INTERFACES
 use interfaces_15gw, except_this_one => dinterp
#endif
!End of the abilint section

implicit none
integer n
complex :: z(n), f(n), z0, zz
integer i
complex a, b
complex :: c(n), zz_minus_z0_to_i
real(dp) :: x(n), smrt
!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifndef HAVE_FORTRAN_INTERFACES
 real(dp) :: clinfit
#endif
!End of the abilint section

x(:) = real(z(:))
smrt = clinfit(n,x,f,a,b)
if( smrt>0.1/Ha_eV) then
  write(*,*) '**WARNING: the values are not linear'
  write(*,*) smrt,a,b,f
endif
dinterp = a
return
end


function clinfit(n,x,z,a,b)
use defs_basis
implicit none
integer n
real(dp) :: clinfit, x(n)
complex :: z(n), a, b
integer i
real(dp) :: sx, sx2, msrt
complex :: sz, sxz

sx=0 ; sz=0 ; sxz=0; sx2=0 ; msrt=0
do i = 1, n
  sx = sx + x(i)
  sz = sz + z(i)
  sxz = sxz + x(i) * z(i)
  sx2 = sx2 + x(i) * x(i)
enddo
a=(n*sxz-sx*sz)/(n*sx2-sx*sx)
b=sz/n-sx*a/n
do i = 1, n
  msrt = msrt + abs(z(i) -a*x(i)-b)**2
enddo
msrt = sqrt(msrt)
clinfit = msrt
return
end

complex function taylor_interp(n,z,f,z0,zz)
! calculate in zz the Taylor polinomial around z0 that interpolate the function f
! at the n points z

!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifdef HAVE_FORTRAN_INTERFACES
 use interfaces_15gw, except_this_one => taylor_interp
#endif
!End of the abilint section

implicit none
integer n
complex :: z(n), f(n), z0, zz
integer i
complex :: c(n), zz_minus_z0_to_i

call calculate_taylor_c(n,z,f,z0,c)

! calculate the Taylor polinomial in zz
zz_minus_z0_to_i = 1
taylor_interp = 0
do i = 1, n
  taylor_interp = taylor_interp + c(i) * zz_minus_z0_to_i
  zz_minus_z0_to_i = zz_minus_z0_to_i * (zz - z0)
enddo
return
end


complex function dtaylor_interp(n,z,f,z0,zz)
! calculate in zz the Taylor polinomial derivative

!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifdef HAVE_FORTRAN_INTERFACES
 use interfaces_15gw, except_this_one => dtaylor_interp
#endif
!End of the abilint section

implicit none
integer n
complex :: z(n), f(n), z0, zz
integer i
complex :: c(n), zz_minus_z0_to_i

call calculate_taylor_c(n,z,f,z0,c)

! calculate the Taylor polinomial in zz
zz_minus_z0_to_i = 1
dtaylor_interp = 0
do i = 2, n
  dtaylor_interp = dtaylor_interp + (i-1) * c(i) * zz_minus_z0_to_i
  zz_minus_z0_to_i = zz_minus_z0_to_i * (zz - z0)
enddo
return
end


subroutine calculate_taylor_c(n,z,f,z0,c)
! calculate the Taylor coefficients polinomial expansion around z0
! for the function f at the n points z
implicit none
integer n
complex :: z(n), f(n), z0, c(n)
integer, parameter :: nrhs=1
integer i,j,info,ipiv(n)
complex :: a(n,n), bb(n,nrhs)

! calculate the coefficient matrix
a(:,1) = 1
do i = 1, n
  do j = 2, n
    a(i,j) = a(i,j-1) * (z(i) - z0)
  enddo
enddo

! solve the linear system to find the Taylor expansion coefficients
bb(:,1) = f(:)
stop 'introduce cgesv'
!call cgesv(n,nrhs,a,n,ipiv,bb,n,info)
if(info/=0) then
  print *, info
  stop 'cgesv failed'
endif
c(:) = bb(:,1)
return
end


complex function pade_approx(n,z,f,zz)
! calculate the pade approximant in zz of the function f calculated at the n points z

!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifdef HAVE_FORTRAN_INTERFACES
 use interfaces_15gw, except_this_one => pade_approx
#endif
!End of the abilint section

implicit none
integer n
complex z(n), f(n)
complex zz

complex (kind(0.d0)) :: a(n)
complex (kind(0.d0)) :: Az(0:n), Bz(0:n)
integer i

call calculate_pade_a(a,n,z,f)

Az(0) = 0
Az(1) = a(1)
Bz(0) = 1
Bz(1) = 1
do i = 1, n-1
  Az(i+1) = Az(i) + (zz - z(i)) * a(i+1) * Az(i-1)
  Bz(i+1) = Bz(i) + (zz - z(i)) * a(i+1) * Bz(i-1)
enddo
!print *, 'Bz(n)', Bz(n)
if(real(Bz(n))==0 .and. aimag(Bz(n))==0) print *, 'Bz(n) ', Bz(n)
pade_approx = Az(n) / Bz(n)
!print *, 'pade_approx ', pade_approx
return
end

complex function dpade_approx(n,z,f,zz)
! calculate the derivative of the pade approximant in zz of the function f 
! calculated at the n points z

!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifdef HAVE_FORTRAN_INTERFACES
 use interfaces_15gw, except_this_one => dpade_approx
#endif
!End of the abilint section

implicit none
integer n
complex z(n), f(n)
complex zz

complex (kind(0.d0)) :: a(n)
complex (kind(0.d0)) :: Az(0:n), Bz(0:n)
complex (kind(0.d0)) :: dAz(0:n), dBz(0:n)
integer i

call calculate_pade_a(a,n,z,f)

Az(0) = 0
Az(1) = a(1)
Bz(0) = 1
Bz(1) = 1
dAz(0) = 0
dAz(1) = 0
dBz(0) = 0
dBz(1) = 0
do i = 1, n-1
  Az(i+1) = Az(i) + (zz - z(i)) * a(i+1) * Az(i-1)
  Bz(i+1) = Bz(i) + (zz - z(i)) * a(i+1) * Bz(i-1)
  dAz(i+1) = dAz(i) + a(i+1) * Az(i-1) + (zz - z(i)) * a(i+1) * dAz(i-1)
  dBz(i+1) = dBz(i) + a(i+1) * Bz(i-1) + (zz - z(i)) * a(i+1) * dBz(i-1)
enddo
!print *, 'Bz(n)', Bz(n)
if(real(Bz(n))==0 .and. aimag(Bz(n))==0) print *, 'Bz(n) ', Bz(n)
!pade_approx = Az(n) / Bz(n)
dpade_approx = dAz(n) / Bz(n) - Az(n) * dBz(n) / (Bz(n)*Bz(n))
!print *, 'pade_approx ', pade_approx
return
end


subroutine calculate_pade_a(a,n,z,f)
implicit none
integer n
complex z(n), f(n)
complex (kind(0.d0)) :: a(n)

complex (kind(0.d0)) :: g(n,n)
integer i, j

g(1,1:n) = f(1:n)
  
do i = 2, n
  do j = i, n
    if(real(g(i-1,j))==0.0 .and. aimag(g(i-1,j))==0.0) print *, 'g_i(z_j)', i, j, g(i,j)
    g(i,j) = (g(i-1,i-1) - g(i-1,j)) / ((z(j) - z(i-1)) * g(i-1,j))
!    print *, 'g_i(z_j)', i, j, g(i,j)
  enddo
enddo
do i = 1, n
  a(i) = g(i,i)
enddo
!print *, 'a ', a(:)
return
end



complex function newton_raphson_step(z,f,df)
! apply single step the newton-raphson method to find the next z close to a 0
! z_k+1 = z_k - H^-1(z_k) f(z_k)
! where H is the Hessian of f in z_k 
implicit none
complex :: z, f, df
newton_raphson_step = z - 1 / (abs(df)*abs(df)) * &
& cmplx(real(f)*real(df)+aimag(f)*aimag(df),-real(f)*aimag(df)+aimag(f)*real(df))
return 
end


