!{\src2tex{textfont=tt}}
!!****f* ABINIT/printv
!! NAME
!! printv
!!
!! FUNCTION
!! Print parts of aa (complex vector)
!! (actually, aa(1:15) is printed)
!!
!! COPYRIGHT
!! Copyright (C) 1999-2007 ABINIT group (GMR, VO, LR, RWG)
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!! For the initials of contributors, see ~abinit/doc/developers/contributors.txt .
!!
!! INPUTS
!!  aa(nn)=vector to be printed
!!  nn=dimension of vector
!!
!! OUTPUT
!!  (only printing)
!!
!! PARENTS
!!      screening
!!
!! CHILDREN
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

subroutine printv(aa,nn)

 use defs_basis

 implicit none

!Arguments ------------------------------------
!scalars
 integer :: nn
!arrays
 complex :: aa(nn)

!Local variables-------------------------------
!scalars
 integer :: ii

! *************************************************************************

 write(6,'(i3,2f9.4)') (ii,aa(ii),ii=1,15)
 write(*,*)

end subroutine printv
!!***
