!{\src2tex{textfont=tt}}
!!****f* ABINIT/vxjas
!! NAME
!! vxjas
!!
!! FUNCTION
!! Calculate the exchange potential with relativistic corrections.
!!
!! COPYRIGHT
!! Copyright (C) 1999-2007 ABINIT group (GMR, VO, LR, RWG)
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!! For the initials of contributors, see ~abinit/doc/developers/contributors.txt .
!!
!! INPUTS
!!  rho=density at a specific point
!!
!! OUTPUT
!!  function vxjas=exchange potential
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

function vxjas(rho)

 use defs_basis

!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifdef HAVE_FORTRAN_INTERFACES
 use interfaces_15gw, except_this_one => vxjas
#endif
!End of the abilint section

 implicit none

!Arguments ------------------------------------
!scalars
 real(dp) :: vxjas
 real(dp),intent(in) :: rho

!Local variables ------------------------------

! *************************************************************************
!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifndef HAVE_FORTRAN_INTERFACES
 real(dp) :: rel
#endif
!End of the abilint section

 vxjas=-((3*rho/pi)**0.3333333333)*rel(rho)

 end function vxjas
!!***
