!{\src2tex{textfont=tt}}
!!****f* ABINIT/test_ftgkk
!! NAME
!! test_ftgkk
!!
!! FUNCTION
!!
!! COPYRIGHT
!! Copyright (C) 2004-2007 ABINIT group (MVerstra)
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! INPUTS
!!   elph_ds = elphon datastructure with matrix elements
!!   gprim = reciprocal lattice vectors
!!   natom = number of atoms
!!   nrpt = number of real space points for FT interpolation
!!   rpt = coordinates of real space points for FT interpolation
!!   spqpt = qpoint coordinates
!!   wghatm = weights for pairs of atoms in FT interpolation
!!
!! OUTPUT
!!
!! SIDE EFFECTS
!!
!! NOTES
!!
!! PARENTS
!!
!! CHILDREN
!!      ftgkk
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

subroutine test_ftgkk(elph_ds,gprim,natom,nrpt,rpt,spqpt,wghatm)

 use defs_basis
  use defs_datatypes
  use defs_elphon

!This section has been created automatically by the script Abilint (TD). Do not modify these by hand.
#ifdef HAVE_FORTRAN_INTERFACES
 use interfaces_17ddb, except_this_one => test_ftgkk
#endif
!End of the abilint section

 implicit none

!Arguments ------------------------------------
!scalars
 integer,intent(in) :: natom,nrpt
 type(elph_type),intent(inout) :: elph_ds
!arrays
 real(dp),intent(in) :: gprim(3,3),rpt(3,nrpt),spqpt(3,elph_ds%nqpt)
 real(dp),intent(in) :: wghatm(natom,natom,nrpt)

!Local variables-------------------------------
!scalars
 integer :: iFSkpt,iqpt,qtor,irpt
!arrays
 real(dp),allocatable :: gkq_disk(:,:,:,:,:)
 real(dp),allocatable :: tmp_gkq(:,:,:,:,:)
 real(dp),allocatable :: gkk_qpt_k(:,:,:,:,:,:)
 real(dp),allocatable :: gkk_rpt_k(:,:,:,:,:,:)

! *************************************************************************

  ! for each qpt do FT to recuperate original values

   qtor = 0

   allocate (gkq_disk(2,elph_ds%ngkkband,elph_ds%ngkkband,elph_ds%nbranch,elph_ds%nbranch))
   allocate (tmp_gkq(2,elph_ds%ngkkband,elph_ds%ngkkband,elph_ds%nbranch,elph_ds%nbranch))

   allocate(gkk_qpt_k(2,elph_ds%ngkkband,elph_ds%ngkkband,3*natom,3*natom,elph_ds%nqpt))
   allocate(gkk_rpt_k(2,elph_ds%ngkkband,elph_ds%ngkkband,3*natom,3*natom,nrpt))

   do iqpt=1,elph_ds%nqpt

! loop over kpoints
     do iFSkpt=1,elph_ds%nFSkpt
       tmp_gkq(:,:,:,:,:) = zero

       if (elph_ds%gkqwrite == 0) then  ! if data in mem
         gkk_rpt_k(:,:,:,:,:,:) = elph_ds%gkk_rpt(:,:,:,:,:,iFSkpt,:)
       else                             ! if data on disk
! read in all rpoints for this kpoint
         do irpt=1,nrpt
           read(elph_ds%unit_gkk_rpt,rec=(iFSkpt+(irpt-1)*elph_ds%nFSkpt)) gkk_rpt_k(:,:,:,:,:,irpt)
         end do
       end if

       call ftgkk (wghatm,tmp_gkq,gkk_rpt_k,gprim,&
            & natom,elph_ds%ngkkband,elph_ds%nqpt,nrpt,qtor,rpt,spqpt)

       if (iFSkpt < 11) then
         if (elph_ds%gkqwrite == 0) then
            write (93,*) tmp_gkq(:,:,:,:,:)-elph_ds%gkk_qpt(:,:,:,:,:,iFSkpt,iqpt)
         else
            read (elph_ds%unitgkq,REC=(iFSkpt+(iqpt-1)*elph_ds%nFSkpt)) gkq_disk
            write (93,*) tmp_gkq(:,:,:,:,:)-gkq_disk(:,:,:,:,:)
         end if
       end if

     end do   ! iFSkpt
   end do     ! iqpt

   deallocate (gkk_qpt_k,gkk_rpt_k,tmp_gkq,gkq_disk)

end subroutine test_ftgkk
!!***
