!{\src2tex{textfont=tt}}
!!****m* ABINIT/defs_time
!! NAME
!! defs_time
!!
!! FUNCTION
!! This module contains accumulators for the timer.
!!
!! COPYRIGHT
!! Copyright (C) 2005-2007 ABINIT group (TD)
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! TODO
!! Include the name of all routines: better modularity
!!
!! PARENTS
!!    timab,time_accu
!!
!! SOURCE

#if defined HAVE_CONFIG_H
#include "config.h"
#endif

module defs_time

 use defs_basis

 implicit none

!mtim determines the maximum number of "timing slots" available
 integer,parameter :: mtim=599

!timeopt is a flag which indicates the suppression or not of the timing.
 integer :: timopt=1

!Number of times that the routine has been called
 integer :: ncount(mtim)

!Accumulating cpu time (1) and wall to wall time (2) for each "timing slots"
 real(dp)  :: acctim(2,mtim),tzero(2,mtim)

end module defs_time
!!***
