!!****m* ABINIT/interfaces_13ionetcdf
!! NAME
!! interfaces_13ionetcdf
!!
!! FUNCTION
!! This module contains the interfaces of the routines
!! in the directory src/13ionetcdf
!!
!! COPYRIGHT
!! Copyright (C) 2005 ABINIT group
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! NOTES
!! THIS FILE IS GENERATED AUTOMATICALLY BY abilint.
!! To do that: abilint . .
!!             (see util/maintainers/abilint.py)
!!
!! SOURCE

module interfaces_13ionetcdf

 interface
  subroutine abi_etsf_electrons_put(dtset, filapp)
   use defs_basis
   use defs_datatypes
   type(dataset_type),intent(in) :: dtset
   character(len=fnlen),intent(in) :: filapp
  end subroutine abi_etsf_electrons_put
 end interface

 interface
  subroutine abi_etsf_geo_put(dtset, filapp, psps, rprimd, xred)
   use defs_basis
   use defs_datatypes
   type(dataset_type),intent(in) :: dtset
   character(len=fnlen),intent(in) :: filapp
   type(pseudopotential_type),intent(in) :: psps
   real(dp),intent(in),target :: rprimd(3,3)
   real(dp),intent(in),target :: xred(3,dtset%natom)
  end subroutine abi_etsf_geo_put
 end interface

 interface
  subroutine abi_etsf_init(dtset, filapp, itype, lmn_size, psps, wfs)
   use defs_basis
   use defs_datatypes
   integer,intent(in) :: itype
   type(dataset_type),intent(in) :: dtset
   character(len=fnlen),intent(in) :: filapp
   type(pseudopotential_type),intent(in) :: psps
   type(wvl_wf_type),intent(in) :: wfs
   integer,intent(in) :: lmn_size(psps%npsp)
  end subroutine abi_etsf_init
 end interface

 interface
  subroutine hdr_io_etsf(fform,hdr,rdwr,unitwff)
   use defs_datatypes
   integer,intent(inout) :: fform
   integer,intent(in) :: rdwr
   integer,intent(in) :: unitwff
   type(hdr_type),intent(inout) :: hdr
  end subroutine hdr_io_etsf
 end interface

 interface
  subroutine ini_wf_etsf(dtset, lmn_size, npsp, ntypat, unwff)
   use defs_datatypes
   integer,intent(in) :: npsp
   integer,intent(in) :: ntypat
   integer,intent(in) :: unwff
   type(dataset_type),intent(in) :: dtset
   integer,intent(in) :: lmn_size(npsp)
  end subroutine ini_wf_etsf
 end interface

 interface
  subroutine ini_wf_netcdf(mpw,ncid_hdr,response)
   integer,intent(in) :: mpw
   integer,intent(in) :: ncid_hdr
   integer,intent(in) :: response
  end subroutine ini_wf_netcdf
 end interface

end module interfaces_13ionetcdf
!!***
