!!****m* ABINIT/interfaces_14wvl_wfs
!! NAME
!! interfaces_14wvl_wfs
!!
!! FUNCTION
!! This module contains the interfaces of the routines
!! in the directory src/14wvl_wfs
!!
!! COPYRIGHT
!! Copyright (C) 2005 ABINIT group
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! NOTES
!! THIS FILE IS GENERATED AUTOMATICALLY BY abilint.
!! To do that: abilint . .
!!             (see util/maintainers/abilint.py)
!!
!! SOURCE

module interfaces_14wvl_wfs

 interface
  subroutine wvl_free_type_wfs(wfs)
   use defs_datatypes
   type(wvl_wf_type),intent(inout) :: wfs
  end subroutine wvl_free_type_wfs
 end interface

 interface
  subroutine wvl_free_type_proj(proj)
   use defs_datatypes
   type(wvl_projectors_type),intent(inout) :: proj
  end subroutine wvl_free_type_proj
 end interface

 interface
  subroutine wvl_free_type_keyArrays(keys)
   use defs_datatypes
   type(wvl_keyArrays_type),intent(inout) :: keys
  end subroutine wvl_free_type_keyArrays
 end interface

 interface
  subroutine wvl_init_type_proj(dtset, mpi_enreg, proj, psps, rprimd, xred)
   use defs_basis
   use defs_datatypes
   type(dataset_type),intent(in) :: dtset
   type(MPI_type),intent(in) :: mpi_enreg
   type(wvl_projectors_type),intent(inout) :: proj
   type(pseudopotential_type),intent(in) :: psps
   real(dp),intent(in) :: rprimd(3,3)
   real(dp),intent(inout) :: xred(3,dtset%natom)
  end subroutine wvl_init_type_proj
 end interface

 interface
  subroutine wvl_init_type_wfs(dtset, mpi_enreg, psps, rprimd, wfs, xred)
   use defs_basis
   use defs_datatypes
   type(dataset_type),intent(in) :: dtset
   type(MPI_type),intent(in) :: mpi_enreg
   type(pseudopotential_type),intent(in) :: psps
   type(wvl_wf_type),intent(inout) :: wfs
   real(dp),intent(in) :: rprimd(3,3)
   real(dp),intent(inout) :: xred(3,dtset%natom)
  end subroutine wvl_init_type_wfs
 end interface

 interface
  subroutine wvl_nl_gradient(dtset, grnl, mpi_enreg, occ, psps, rprimd, wvl, xcart)
   use defs_basis
   use defs_datatypes
   type(dataset_type), intent(inout) :: dtset
   type(MPI_type), intent(inout) :: mpi_enreg
   type(pseudopotential_type), intent(in) :: psps
   type(wvl_data), intent(in) :: wvl
   real(dp), intent(in) :: rprimd(3, 3)
   real(dp), intent(inout) :: grnl(3, dtset%natom)
   real(dp), intent(in) :: occ(dtset%mband * dtset%nkpt *dtset%nsppol)
   real(dp), intent(in) :: xcart(3, dtset%natom)
  end subroutine wvl_nl_gradient
 end interface

 interface
  subroutine wvl_setngfft(dtset, mpi_enreg)
   use defs_datatypes
   type(dataset_type), intent(inout) :: dtset
   type(MPI_type), intent(inout) :: mpi_enreg
  end subroutine wvl_setngfft
 end interface

 interface
  subroutine wvl_tail_corrections(dtset, energies, etotal, mpi_enreg, occ, psps,&  
&  vtrial, wvl, xcart)
   use defs_basis
   use defs_datatypes
   type(dataset_type), intent(inout) :: dtset
   type(energies_type), intent(inout) :: energies
   real(dp), intent(out) :: etotal
   type(MPI_type), intent(inout) :: mpi_enreg
   type(pseudopotential_type), intent(in) :: psps
   type(wvl_data), intent(inout) :: wvl
   real(dp), intent(in) :: occ(dtset%mband * dtset%nkpt *dtset%nsppol)
   real(dp), target, intent(in) :: vtrial(dtset%nfft)
   real(dp), intent(in) :: xcart(3, dtset%natom)
  end subroutine wvl_tail_corrections
 end interface

end module interfaces_14wvl_wfs
!!***
